{ pkgs, lib, config, ... }:
with lib;
{
  options.components.gui = {
    enable = lib.mkEnableOption "GUI configurations";
  };

  imports = [
    # todo : structure with home-manager and such is not cool, create another structure
    ./audio.nix
    ./browser.nix
    ./cups.nix
    ./fonts.nix
    ./home-manager
    ./kmonad.nix
    ./noti.nix
    ./pass.nix
    ./steam.nix
    ./suspend.nix
    ./taskwarrior.nix
    ./vscode.nix
    ./xorg
  ];

  config = mkIf config.components.gui.enable {
    # todo extract xorg stuff to prepare wayland
    environment.enableAllTerminfo = true;
  };
}
