{ pkgs, config, lib, ... }:
with lib;
{
  options.components.gui.style.enable = mkOption {
    type = lib.types.bool;
    default = config.components.gui.enable;
  };

  config = mkIf (config.components.gui.style.enable) {

    fonts.packages = with pkgs; [

      corefonts
      hasklig
      inconsolata
      source-code-pro
      symbola
      ubuntu_font_family

      # symbol fonts
      # ------------
      nerdfonts
      powerline-fonts
      font-awesome
      fira-code-symbols
      jetbrains-mono

      # shell font
      # ----------
      terminus_font
      gohufont

    ];

  };
}
