{ config, pkgs, lib, ... }:
with lib;
{
  options.components.terminal = {
    enable = mkOption {
      type = types.bool;
      default = true;
    };
  };

  imports = [
    ./direnv.nix
    ./git.nix
    ./heygpt.nix
    ./hoard.nix
    ./oh-my-posh
    ./remote-install.nix
    ./wtf.nix
    ./zsh.nix
  ];

  config = mkIf config.components.terminal.enable {
    environment.systemPackages = [
      pkgs.ranger # datei browser
      pkgs.retry # retry command till success
      pkgs.silver-searcher
      pkgs.treefmt
    ];
  };
}
