{ config, pkgs, lib, ... }:
with pkgs;
with lib;
{
  config = mkMerge [
    {
      home.packages = [
        bind.dnsutils
        nmap
        hexyl
        ipcalc

        units

        parallel

        wget
        curl

        gimoji

        # todo : configure this properly
        tldr

        bandwhich
      ];

      programs.btop.enable = true;

    }


    (mkIf config.gui.enable {
      home.packages = [
        libreoffice
        hunspell
        hunspellDicts.de-de
        hunspellDicts.en-us
        aspell
        aspellDicts.de
        aspellDicts.en
        aspellDicts.es

        evince
        sxiv
        gimp
        inkscape

        transmission-remote-gtk
      ];
    })
  ];
}
