{ pkgs, ... }:
with pkgs;
{

  programs.git = {
    enable = true;
    userName = "Ingolf Wagner";
    userEmail = "contact@ingolf-wagner.de";
    signing = {
      key = "42AC51C9482D0834CF488AF1389EC2D64AC71EAC";
      signByDefault = true;
    };
    ignores = [ "*.swp" "*~" ".idea" ".*penis.*" "result" ".envrc" ".direnv" ];
    extraConfig = {
      init.defaultBranch = "main";
      pull.ff = "only";
    };
    #diff-so-fancy.enable = true;
    difftastic.enable = true;
  };


  home.packages = [
    pre-commit
    gita
    tig
    lazygit
    git-crypt
    gitAndTools.gitflow
    gitAndTools.gitSVN
    gitAndTools.git2cl
  ];

}
