{ config, ... }:
{
  services.minio = {
    enable = true;
    region = "home";
    rootCredentialsFile = config.sops.secrets.minioRootCredentials.path;
  };

  sops.secrets.minioRootCredentials = { };

  services.nginx = {
    enable = true;
    virtualHosts."s3.${config.networking.hostName}.private" = {
      locations."/" = {
        recommendedProxySettings = true;
        proxyWebsockets = true;
        proxyPass = "http://localhost:9000";
      };
    };
    virtualHosts."minio.${config.networking.hostName}.private" = {
      locations."/" = {
        recommendedProxySettings = true;
        proxyWebsockets = true;
        proxyPass = "http://localhost:9001";
      };
    };
  };
}
