{ lib, config, pkgs, ... }: {
  imports = [

    ./hardware-configuration

    ../../system/all/defaults.nix

    ../../components
    ../../modules


    # services
    #./borg.nix
    #./codimd.nix
    #./gitea.nix
    #./nextcloud.nix
    #./packages.nix
    #./taskserver.nix
    #./vaultwarden.nix
    #./nginx.nix
    #./nginx-wkd.nix

    ./network-tinc.nix
    #./network-wireguard.nix

    #./media-share.nix
    #./media-jellyfin.nix
    #./media-syncthing.nix
    #./media-transmission.nix
    #./media-transmission2.nix
    #./media-arr.nix

    #./sync-opentracker.nix
    #./sync-torrent.nix

    #./social-jitsi.nix
    ./social-matrix.nix

    # matrix
    # ------
    #./terranix-dendrite.nix

    # logging
    #./loki.nix
    #./loki-promtail.nix
    ##./prometheus.nix
    #./grafana.nix
    ./telegraf.nix

    #./cache.nix
  ];

  networking.hostName = "orbi";


  components.terminal.enable = true;
  components.mainUser.enable = true;
  components.gui.enable = false;
  components.network.enable = true;
  components.network.wifi.enable = false;

  security.acme.acceptTerms = true;
  security.acme.defaults.email = "contact@ingolf-wagner.de";

  sops.defaultSopsFile = ../../secrets/orbi.yaml;

}
